"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var HttpServer_1 = require("./base/HttpServer");
var express = require("express");
var _ = require("lodash");
var HttpMethod_1 = require("./common/HttpMethod");
var Route_1 = require("./common/Route");
var compression = require("compression");
var helmet = require("helmet");
var bodyParser = require("body-parser");
var cookieParser = require("cookie-parser");
var session = require("express-session");
var cors = require("cors");
var Response_1 = require("./common/Response");
var DEFAULT_SESSION_SECRET = '220183';
var Options = /** @class */ (function () {
    function Options() {
    }
    return Options;
}());
var WebServer = /** @class */ (function (_super) {
    __extends(WebServer, _super);
    function WebServer(options) {
        var _this = this;
        var application = express();
        _this = _super.call(this, application) || this;
        _this.root = undefined;
        _this.controllers = [];
        _this.express = application;
        /* default routes */
        _this.express.use(bodyParser.urlencoded({ extended: true }));
        _this.express.use(bodyParser.json());
        _this.express.use(cookieParser());
        _this.express.use(session({
            secret: process.env.SESSION_SECRET ? process.env.SESSION_SECRET : DEFAULT_SESSION_SECRET,
            name: 'minmin.sid',
            resave: false,
            saveUninitialized: false,
            cookie: { maxAge: 1000 * 60 * 60 * 24 }
        }));
        _this.express.use(compression({ threshold: 0 }));
        _this.express.use(helmet());
        if (options && options.useCors)
            _this.express.use(cors());
        if (options && options.nuxt) {
            var Nuxt = require('nuxt').Nuxt;
            _this.nuxt = new Nuxt(options.nuxt);
        }
        return _this;
    }
    WebServer.validResponse = function (result) {
        return result.exec !== undefined;
    };
    WebServer.prototype.getControllers = function () {
        return this.controllers;
    };
    WebServer.prototype.getApplication = function () {
        return this.express;
    };
    WebServer.prototype.getRoot = function () {
        return this.root;
    };
    WebServer.prototype.setRoot = function (value) {
        this.root = value;
        return this;
    };
    WebServer.prototype.start = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.initialize()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, _super.prototype.start.call(this)];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    WebServer.prototype.resolveTarget = function (instance, target) {
        for (var key in target) {
            if (target.hasOwnProperty(key)) {
                if (Reflect.hasMetadata("custom:inject", target, key)) {
                    var propertyConstructor = Reflect.getMetadata('design:type', target, key);
                    if (Reflect.hasMetadata("custom:service", propertyConstructor.prototype)) {
                        instance[key] = new propertyConstructor;
                        this.resolveTarget(instance[key], propertyConstructor.prototype);
                    }
                }
            }
        }
    };
    WebServer.prototype.initialize = function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_1, _a, Builder, router, controllers, _loop_1, this_1, controllers_1, controllers_1_1, controller;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(this.nuxt && this.nuxt.options.dev)) return [3 /*break*/, 2];
                        Builder = require('nuxt').Builder;
                        return [4 /*yield*/, new Builder(this.nuxt).build()];
                    case 1:
                        _b.sent();
                        _b.label = 2;
                    case 2:
                        router = express.Router();
                        controllers = WebServer.prototypeControllers;
                        _loop_1 = function (controller) {
                            var target = controller.prototype;
                            var routes = Reflect.getOwnMetadata('custom:routes', target);
                            var parameters = Reflect.getOwnMetadata('custom:parameters', target);
                            var instance = new controller;
                            this_1.controllers.push(instance);
                            this_1.resolveTarget(instance, target);
                            _.keys(routes)
                                .map(function (key) { return routes[key]; })
                                .forEach(function (route) {
                                var url = Route_1.buildUrl(target, route.name, route.url, _this.root);
                                _this.getLogger().info(HttpMethod_1.HttpMethod[route.method] + ' - ' + url);
                                if (route.middlewares)
                                    router[HttpMethod_1.HttpMethod[route.method]](url, route.middlewares, _this.createRoute(route, instance, parameters));
                                else
                                    router[HttpMethod_1.HttpMethod[route.method]](url, _this.createRoute(route, instance, parameters));
                            });
                        };
                        this_1 = this;
                        try {
                            for (controllers_1 = __values(controllers), controllers_1_1 = controllers_1.next(); !controllers_1_1.done; controllers_1_1 = controllers_1.next()) {
                                controller = controllers_1_1.value;
                                _loop_1(controller);
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (controllers_1_1 && !controllers_1_1.done && (_a = controllers_1.return)) _a.call(controllers_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                        this.express.use(router);
                        if (this.nuxt) {
                            this.express.use(this.nuxt.render);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    WebServer.prototype.createRoute = function (route, instance, parameters) {
        var _this = this;
        return function (req, res) { return __awaiter(_this, void 0, void 0, function () {
            var e_2, _a, values, params, params_1, params_1_1, param, result, e_3;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        values = [];
                        if (parameters) {
                            params = parameters[route.name];
                            if (params) {
                                try {
                                    for (params_1 = __values(params), params_1_1 = params_1.next(); !params_1_1.done; params_1_1 = params_1.next()) {
                                        param = params_1_1.value;
                                        values[param.index] = param.getValue(req);
                                    }
                                }
                                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                                finally {
                                    try {
                                        if (params_1_1 && !params_1_1.done && (_a = params_1.return)) _a.call(params_1);
                                    }
                                    finally { if (e_2) throw e_2.error; }
                                }
                            }
                        }
                        result = route.callback.apply(instance, values);
                        if (!(result && typeof result.then === 'function')) return [3 /*break*/, 4];
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, result];
                    case 2:
                        result = _b.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_3 = _b.sent();
                        this.getLogger().error(e_3);
                        result = new Response_1.Error(e_3.message);
                        return [3 /*break*/, 4];
                    case 4:
                        if (result && WebServer.validResponse(result)) {
                            return [2 /*return*/, result.exec(res)];
                        }
                        else {
                            throw new Error('Invalid return type.');
                        }
                        return [2 /*return*/];
                }
            });
        }); };
    };
    WebServer.prototypeControllers = [];
    return WebServer;
}(HttpServer_1.HttpServer));
exports.WebServer = WebServer;

//# sourceMappingURL=WebServer.js.map
