"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Server_1 = require("./Server");
var http = require("http");
var HttpServer = /** @class */ (function (_super) {
    __extends(HttpServer, _super);
    function HttpServer(express) {
        var _this = _super.call(this) || this;
        if (express) {
            _this.httpServer = http.createServer(express);
        }
        else {
            _this.httpServer = http.createServer();
        }
        return _this;
    }
    HttpServer.prototype.getPort = function () {
        return this.port || 3000;
    };
    HttpServer.prototype.setPort = function (value) {
        this.port = value;
        return this;
    };
    HttpServer.prototype.getHttpServer = function () {
        return this.httpServer;
    };
    HttpServer.prototype.start = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (!_this.httpServer)
                return reject(new Error("Failed to create http server."));
            _this.httpServer.on('error', function (error) {
                _this.getLogger().error(error);
                reject(error);
            });
            _this.httpServer.on('listening', function () {
                _this.getLogger().info('Listening on port %s', _this.port);
                resolve(_this.httpServer);
            });
            _this.httpServer.listen(_this.port);
        });
    };
    return HttpServer;
}(Server_1.Server));
exports.HttpServer = HttpServer;

//# sourceMappingURL=HttpServer.js.map
