"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var winston = require("winston");
var moment = require("moment");
var Server = /** @class */ (function () {
    function Server() {
        var _this = this;
        this.logger = new winston.Logger({
            transports: [
                new (winston.transports.Console)(),
                new (winston.transports.File)({
                    filename: 'server.log',
                    timestamp: function () {
                        return moment(new Date()).format('YYYY-MM-DD HH:mm:ss.SSS');
                    },
                    humanReadableUnhandledException: true,
                    maxsize: 1024 * 1024 * 10,
                    maxFiles: 5,
                    json: false
                })
            ]
        });
        process.on('uncaughtException', function (error) {
            _this.getLogger().error(error);
        });
    }
    Server.prototype.getLogger = function () {
        return this.logger;
    };
    return Server;
}());
exports.Server = Server;

//# sourceMappingURL=Server.js.map
