"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var PRIMITIVE_TYPES = [Object, String, Array, Number, Boolean];
var Parameter = /** @class */ (function () {
    function Parameter(type) {
        this.type = type;
    }
    Parameter.prototype.getRawValue = function (value) {
        if (typeof value === 'undefined')
            return null;
        var ctor = this.type;
        if (value.constructor === ctor) {
            return value;
        }
        else {
            return PRIMITIVE_TYPES.indexOf(ctor) !== -1 ? ctor(value) : new ctor(value);
        }
    };
    return Parameter;
}());
exports.Parameter = Parameter;
function getParameters(target) {
    if (!Reflect.hasOwnMetadata('custom:parameters', target)) {
        Reflect.defineMetadata('custom:parameters', {}, target);
    }
    return Reflect.getOwnMetadata('custom:parameters', target);
}
exports.getParameters = getParameters;

//# sourceMappingURL=Parameter.js.map
