import * as express from "express";
export interface IResponse {
    exec(res: express.Response): void;
}
export declare class Result implements IResponse {
    name?: string | undefined;
    content?: any;
    constructor(name?: string | undefined, content?: any);
    exec(res: express.Response): void;
}
export declare class Error implements IResponse {
    message: string;
    code?: number | undefined;
    constructor(message: string, code?: number | undefined);
    exec(res: express.Response): void;
}
export declare class View implements IResponse {
    template: string;
    options?: any;
    constructor(template: string, options?: any);
    exec(res: express.Response): void;
}
export declare class Redirect implements IResponse {
    url: string;
    constructor(url: string);
    exec(res: express.Response): void;
}
