"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Result = /** @class */ (function () {
    function Result(name, content) {
        this.name = name;
        this.content = content;
    }
    Result.prototype.exec = function (res) {
        var object = {
            ok: true
        };
        if (this.name && this.content)
            object[this.name] = this.content;
        res.json(object);
    };
    return Result;
}());
exports.Result = Result;
var Error = /** @class */ (function () {
    function Error(message, code) {
        this.message = message;
        this.code = code;
    }
    Error.prototype.exec = function (res) {
        res.status(this.code ? this.code : 500).json({
            ok: false,
            message: this.message
        });
    };
    return Error;
}());
exports.Error = Error;
var View = /** @class */ (function () {
    function View(template, options) {
        this.template = template;
        this.options = options;
    }
    View.prototype.exec = function (res) {
        res.render(this.template, this.options);
    };
    return View;
}());
exports.View = View;
var Redirect = /** @class */ (function () {
    function Redirect(url) {
        this.url = url;
    }
    Redirect.prototype.exec = function (res) {
        res.redirect(this.url);
    };
    return Redirect;
}());
exports.Redirect = Redirect;

//# sourceMappingURL=Response.js.map
