"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Parameter_1 = require("../../common/Parameter");
var StdParameter_1 = require("../../common/StdParameter");
function Param(name, optional) {
    return function (target, method, index) {
        var parameters = Parameter_1.getParameters(target);
        if (!parameters[method]) {
            parameters[method] = [];
        }
        var type = Reflect.getOwnMetadata('design:paramtypes', target, method)[index];
        parameters[method].push(new ParamParameter(name, type, index, optional));
    };
}
exports.Param = Param;
var ParamParameter = /** @class */ (function (_super) {
    __extends(ParamParameter, _super);
    function ParamParameter(name, type, index, optional) {
        var _this = _super.call(this, name, type, index) || this;
        _this.name = name;
        _this.type = type;
        _this.index = index;
        _this.optional = optional;
        if (!_this.name) {
            _this.name = 'value' + _this.index;
        }
        _this.name += (optional ? '?' : '');
        return _this;
    }
    ParamParameter.prototype.getValue = function (req) {
        var paramName = this.name.endsWith('?') ? this.name.substr(0, this.name.length - 1) : this.name;
        return this.getRawValue(req.params[paramName]);
    };
    return ParamParameter;
}(StdParameter_1.StdParameter));
exports.ParamParameter = ParamParameter;

//# sourceMappingURL=Param.js.map
